;	TITLE (C) LCD FREQUENCY COUNTER 4/10/2014
;	V1 adding a FE-5680A Rubidium Freq Standard 10MHz

;-----------------------------------------------------------------------------
       .equ __30F4012, 1
        .include "p30f4012.inc"
;..............................................................................
;Program Specific Constants (literals used in code)
;..............................................................................
;-------------- global declarations ---------------------------------------
	.global __reset

;..............................................................................
;Constants stored in Program space
;..............................................................................
        .section .myconstbuffer, psv
;------ general Constants -----------------------------
;define constant
;PORTB
	.equ	range, 0
	.equ	sw2, 2
	.equ	sw1, 3
;PORTC
	.equ	prescaler, 13
	.equ	standard, 14
;PORTD
	.equ	flock, 0
;PORTE
	.equ	sda, 0
	.equ	scl, 1

	.equ	Ticks1s, 200		;Number of T1 interrupts/second
	.equ	HistorySize, 10		;10 seconds of history

;------ I/O Port constants -----------------------------
;define ram assignments
	.bss	dig1,2
	.bss	dig2,2
	.bss	dig3,2
	.bss	dig4,2
	.bss	dig5,2
	.bss	dig6,2
	.bss	dig7,2
	.bss	dig8,2
	.bss	dig9,2
	.bss	dig10,2
	.bss	dig11,2
	.bss	delay1,2
	.bss	delay2,2
	.bss	datbuff,2
	.bss	temp1,2
	.bss	temp2,2
	.bss	temp3,2
	.bss	count,4
	.bss	upper,2
	.bss	lower,2
	.bss	tcg_numb,2
	.bss	line_1,2	;1st Row display ram
	.bss	line_2,2
	.bss	line_3,2
	.bss	line_4,2
	.bss	line_5,2
	.bss	line_6,2
	.bss	line_7,2
	.bss	line_8,2
	.bss	line_9,2
	.bss	line_10,2
	.bss	line_11,2
	.bss	line_12,2
	.bss	line_13,2
	.bss	line_14,2
	.bss	line_15,2
	.bss	line_16,2
	.bss	line_17,2	;2nd Row display ram
	.bss	line_18,2
	.bss	line_19,2
	.bss	line_20,2
	.bss	line_21,2
	.bss	line_22,2
	.bss	line_23,2
	.bss	line_24,2
	.bss	line_25,2
	.bss	line_26,2
	.bss	line_27,2
	.bss	line_28,2
	.bss	line_29,2
	.bss	line_30,2
	.bss	line_31,2
	.bss	line_32,2

	.bss	flags,2
	.bss	T1_Ticks,2
	.bss	T2_Prev,2
	.bss	T3_Prev,2
	.bss	FreqHistory, 6*HistorySize
	.bss	addr,2

;------------------------------------------------------
;	       		28 PIN DIL 
;			dsPIC30F4012
;                     ______  ______
;		     |      \/      |
;   PROGRAMER/MCLR --+ 1         28 +-- RB7  AVdd	
;	             |              |
;  RANGE INPUT/RB0 --+ 2         27 +-- RB6  AVss
;	             |              |
;              RB1 --+ 3         26 +-- RE0  SDA DISPLAY		
;	             |              |
;          SW1/RB2 --+ 4         25 +-- RE1  SCL DISPLAY
;	             |              |
;    	   SW2/RB3 --+ 5         24 +-- RE2  
;	             |              |
;   	       RB4 --+ 6         23 +-- RE3
;	             |              |
;              RB5 --+ 7         22 +-- RE4
;	             |              |
;              VSS  -+ 8         21 +-- RE5
;	             |              |
;              OSC --+ 9         20 +-- VDD
;	             |              |
;             RC15 --+ 10        19 +-- VSS
;	             |              |
;	 T2CK/RC13 --+ 11        18 +-- RC7/PGC	
;	             |              |
;	 T1CK/RC14 --+ 12        17 +-- RC6/PGD
;	             |              |
;              VDD --+ 13        16 +-- RE8
;	             |              |
;              RD1 --+ 14        15 +-- RD0/LOCK INPUT	       	
;                    |______________|
;
;			PCF8574T
;                     ______  ______
;		     |      \/      |
;               A0 --+ 1         16 +-- Vcc	
;	             |              |
;               A1 --+ 2         15 +-- SDA
;	             |              |
;               A2 --+ 3         14 +-- SCL		
;	             |              |
;            RS/P0 --+ 4         13 +-- /INT
;	             |              |
;    	     RW/P1 --+ 5         12 +-- P7/DB7
;	             |              |
;   	      E/P2 --+ 6         11 +-- P6/DB6
;	             |              |
;               P3 --+ 7         10 +-- P5/DB5
;	             |              |
;              GND  -+ 8          9 +-- P4/DB4
;	             |______________|
;
;		          MB506
;		      ______  ______
;		     |      \/      |
;               IN --+ 1          8 +-- IN/	
;	             |              |
;              VCC --+ 2          7 +-- N/C
;	             |              |
;              SW1 --+ 3          6 +-- SW2		
;	             |              |
;              OUT --+ 4          5 +-- GND
;	             |______________| 
;
;------------------------- vector tables ----------------
	.global __reset
	.global __T1Interrupt
;--------------------------------------------------------
;	Configuration bits
;--------------------------------------------------------
	config __FOSC, CSW_FSCM_OFF & FRC_PLL16
	config __FWDT,WDT_OFF
	config __PBORPOR, PBOR_OFF & MCLR_EN
;	config __FGS, CODE_PROT_OFF	
;-------------------------------------------------------
	.text	;start of code
;-----------------------------------------
__reset:
        mov 	#__SP_init, W15       	;Initalize the Stack Pointer
        mov 	#__SPLIM_init, W0     	;Initialize the Stack Pointer Limit Register
        mov 	W0, SPLIM
        nop                     	;Add NOP to follow SPLIM initialization
	mov	#0xffff,w0		
	mov	w0,ADPCFG		
	clr	LATB
	clr	LATC
	clr	LATD
	clr	LATE
	bset    CORCON, #PSV              ;Enable Program Space Visibility
	bra	init	                                 
;----------------------- Initialisation Routine -----------------------
init:
	rcall	init_ports
	rcall	init_timers
	rcall	init_lcd
	rcall	stop_LCD
	clr	dig1
	clr	dig2
	clr	dig3
	clr	dig4
	clr	dig5
	clr	dig6
	clr	dig7
	clr	dig8
	clr	dig9
	clr	dig10
	clr	dig11
	mov	#Ticks1s,w0
	mov	w0,T1_Ticks
	clr	T2_Prev
	clr	T3_Prev
	rcall	ClearFrequencyHistory
	clr	flags
	rcall	start_LCD
	rcall	header_LCD		;I2C address
;	clr	addr
	bra	main

;-------------------------------------------
;Timer 1 Overflow Interrupt 
;Occurs 200 times per second
__T1Interrupt:
	push	w0
	push	w1
	push	w2
	push	w3
	mov	TMR2,w2		;Grab T2:T3 pair
	mov	TMR3HLD,w3	;
	dec	T1_Ticks	;Decrement 1 second Tick Counter
	bra	nz,1f		;1 second elapsed? No - Done

	mov	#Ticks1s,w0	;Yes - Reload Tick Counter
	mov	w0,T1_Ticks	;
	mov	T2_Prev,w0	;Get Count from previous second
	mov	T3_Prev,w1	;
	mov	w2,T2_Prev	;Save current count for next second
	mov	w3,T3_Prev	;
	sub	w2,w0,w0	;Compute difference between two counts
	subb	w3,w1,w1	;
	clr	w2		;Multiply by 2048 to give 48bit frequency
	sl	w0,w0		;2
	rlc	w1,w1		;
	rlc	w2,w2		;
	sl	w0,w0		;4
	rlc	w1,w1		;
	rlc	w2,w2		;
	sl	w0,w0		;8
	rlc	w1,w1		;
	rlc	w2,w2		;
	sl	w0,w0		;16
	rlc	w1,w1		;
	rlc	w2,w2		;
	sl	w0,w0		;32
	rlc	w1,w1		;
	rlc	w2,w2		;
	sl	w0,w0		;64
	rlc	w1,w1		;
	rlc	w2,w2		;
	sl	w0,w0		;128
	rlc	w1,w1		;
	rlc	w2,w2		;
	sl	w0,w0		;256
	rlc	w1,w1		;
	rlc	w2,w2		;
	sl	w0,w0		;512
	rlc	w1,w1		;
	rlc	w2,w2		;
	sl	w0,w0		;1024
	rlc	w1,w1		;
	rlc	w2,w2		;
	sl	w0,w0		;2048
	rlc	w1,w1		;
	rlc	w2,w2		;
	rcall	SaveFrequencyToHistory	;Save Frequency
	bset	flags,#0	;Set Frequency Captured Flag

1:	bclr	IFS0,#T1IF	;Exit T1 Interrupt
	pop	w3		;
	pop	w2		;
	pop	w1		;
	pop	w0		;
	retfie			;

;-------------------- main routines -----------------
main:
	rcall	LCD_Line1
	rcall	line1_Flash_data
	btss	PORTD,#0	;lock input
	rcall	line1_data
	rcall	send_buff1

	rcall	LCD_Line2
	rcall	convert
	rcall	line2_data
	rcall	send_buff2	
waitloop:
	btst	flags,#0
	bra	z,waitloop
	clr	flags
	bra	main
;------ Frequency History Buffer -----------
ClearFrequencyHistory:
	push	w0
	push	w1
	mov	#FreqHistory,w0
	mov	#HistorySize,w1
1:	clr	[w0++]
	clr	[w0++]
	clr	[w0++]
	dec	w1,w1
	bra	nz,1b
	pop	w1
	pop	w0
	return
;-------------------------------------------
SaveFrequencyToHistory:
;Entry W2:W1:W0 = New Frequency Measurement to save into history buffer
	push	w3
	push	w4
	push	w5
	;Shift History Buffer
	mov	#(FreqHistory+(6*(HistorySize-1))),w4	
	mov	#HistorySize,w5
1:	dec	w5,w5
	bra	z,2f
	mov	[w4-6],w3
	mov	w3,[w4+0]
	mov	[w4-4],W3
	mov	w3,[w4+2]
	mov	[w4-2],W3
	mov	w3,[w4+4]
	sub	#6,w4
	bra	1b
2:	;Save New Frequency
	mov	w0,[w4+0]
	mov	w1,[w4+2]
	mov	w2,[w4+4]
	pop	w5
	pop	w4
	pop	w3
	return
;-----------------------------------------------
GetFrequencyHistorySum:
;Entry W3 = Number of seconds of frequency history to sum
;Exit W2:W1:W0 = Sum of frequency history
	push	w3
	push	w4
	clr	w0
	clr	w1
	clr	w2
	mov	#FreqHistory,w4
1:	cp0	w3
	bra	z,2f
	add	w0,[w4++],w0
	addc	w1,[w4++],w1
	addc	w2,[w4++],w2
	dec	w3,w3
	bra	1b
2:	pop	w4
	pop	w3
	return
;-------------------------
convert:			;Convert to Decimal
	btss	PORTB,#range	;1 or 10 second range?
	bra	convert_10s	;
convert_1s:
	mov	#1,w3		;Get Frequency Sum for 1 second
	rcall	GetFrequencyHistorySum	;into W2:W1:W0

	mov	#0x0002,W5	;Divide by 10,000,000,000
	mov	#0x540B,W4	;
	mov	#0xE400,W3	;
	rcall	Div48		;
	mov	w6,dig1		;Save Digit

	mov	#0x0000,W5	;Divide by 1,000,000,000
	mov	#0x3B9A,W4	;
	mov	#0xCA00,W3	;
	rcall	Div48		;
	mov	w6,dig2		;Save Digit

	mov	#0x0000,W5	;Divide by 100,000,000
	mov	#0x05F5,W4	;
	mov	#0xE100,W3	;
	rcall	Div48		;
	mov	w6,dig3		;Save Digit

	mov	#0x0000,W5	;Divide by 10,000,000
	mov	#0x0098,W4	;
	mov	#0x9680,W3	;
	rcall	Div48		;
	mov	w6,dig4		;Save Digit

	mov	#0x0000,W5	;Divide by 1,000,000
	mov	#0x000F,W4	;
	mov	#0x4240,W3	;
	rcall	Div48		;
	mov	w6,dig5		;Save Digit

	mov	#0x0000,W5	;Divide by 100,000
	mov	#0x0001,W4	;
	mov	#0x86A0,W3	;
	rcall	Div48		;
	mov	w6,dig6		;Save Digit

	mov	#0x0000,W5	;Divide by 10,000
	mov	#0x0000,W4	;
	mov	#0x2710,W3	;
	rcall	Div48		;
	mov	w6,dig7		;Save Digit

	mov	#0x0000,W5	;Divide by 1,000
	mov	#0x0000,W4	;
	mov	#0x03E8,W3	;
	rcall	Div48		;
	mov	w6,dig8		;Save Digit

	mov	#0x0000,W5	;Divide by 100
	mov	#0x0000,W4	;
	mov	#0x0064,W3	;
	rcall	Div48		;
	mov	w6,dig9		;Save Digit

	mov	#0x0000,W5	;Divide by 10
	mov	#0x0000,W4	;
	mov	#0x000A,W3	;
	rcall	Div48		;
	mov	w6,dig10	;Save Digit

	mov	w0,dig11	;Save final Digit

	rcall	line2_data
 	return
;------------------------------
convert_10s:
	mov	#10,w3		;Get Frequency Sum for 10 seconds
	rcall	GetFrequencyHistorySum	;into W2:W1:W0

	mov	#0x0017,W5	;Divide by 100,000,000,000
	mov	#0x4876,W4	;
	mov	#0xE800,W3	;
	rcall	Div48		;
	mov	w6,dig1		;Save Digit

	mov	#0x0002,W5	;Divide by 10,000,000,000
	mov	#0x540B,W4	;
	mov	#0xE400,W3	;
	rcall	Div48		;
	mov	w6,dig2		;Save Digit

	mov	#0x0000,W5	;Divide by 1,000,000,000
	mov	#0x3B9A,W4	;
	mov	#0xCA00,W3	;
	rcall	Div48		;
	mov	w6,dig3		;Save Digit

	mov	#0x0000,W5	;Divide by 100,000,000
	mov	#0x05F5,W4	;
	mov	#0xE100,W3	;
	rcall	Div48		;
	mov	w6,dig4		;Save Digit

	mov	#0x0000,W5	;Divide by 10,000,000
	mov	#0x0098,W4	;
	mov	#0x9680,W3	;
	rcall	Div48		;
	mov	w6,dig5		;Save Digit

	mov	#0x0000,W5	;Divide by 1,000,000
	mov	#0x000F,W4	;
	mov	#0x4240,W3	;
	rcall	Div48		;
	mov	w6,dig6		;Save Digit

	mov	#0x0000,W5	;Divide by 100,000
	mov	#0x0001,W4	;
	mov	#0x86A0,W3	;
	rcall	Div48		;
	mov	w6,dig7		;Save Digit

	mov	#0x0000,W5	;Divide by 10,000
	mov	#0x0000,W4	;
	mov	#0x2710,W3	;
	rcall	Div48		;
	mov	w6,dig8		;Save Digit

	mov	#0x0000,W5	;Divide by 1,000
	mov	#0x0000,W4	;
	mov	#0x03E8,W3	;
	rcall	Div48		;
	mov	w6,dig9		;Save Digit

	mov	#0x0000,W5	;Divide by 100
	mov	#0x0000,W4	;
	mov	#0x0064,W3	;
	rcall	Div48		;
	mov	w6,dig10	;Save Digit

	mov	#0x0000,W5	;Divide by 10
	mov	#0x0000,W4	;
	mov	#0x000A,W3	;
	rcall	Div48		;
	mov	w6,dig11	;Save final Digit

	rcall	line2_data
 	return
;------------------ 48 Bit Divide ----------------------------
;Entry	W2:W1:W0	Dividend
;	W5:W4:W3	Divisor
;
;Exit	W6		Quotient (16 bit)
;	W2:W1:W0	Remainder

Div48:	clr	w6		;Clear Quotient
1:	inc	w6,w6		;Increment Quotient
	sub	w0,w3,w0	;Subtract Divisor from Dividend
	subb	w1,w4,w1	;
	subb	w2,w5,w2	;
	btst	w2,#15		;Negative ?
	bra	z,1b		;No - Keep subtracting
	dec	w6,w6		;Yes - Gone too far
	add	w0,w3,w0	;Add an interation back
	addc	w1,w4,w1	;
	addc	w2,w5,w2	;
	return			;Done
;------------------ INIT LCD START ADDRESS -------------------
LCD_Line1:
	mov	#0x80,w0	;send address to control register
	call	bld_command
	return
LCD_Line2:
	mov	#0xc0,w0	;send address to control register
	call	bld_command
	return
;-----------------------------------------------------
init_lcd:
;		01	REGISTER SELECT
;		02	READ/WRITE SELECT
;		04	ENABLE BIT
	call	start_LCD
	call	header_LCD	;send i2c address "7E"
	mov	#0x38,w0
	mov	w0,datbuff	;set DL to be 4 bit
	call	sendlcd
	mov	#0x38,w0
	mov	w0,datbuff	;1
	call	sendlcd
	mov	#0x04,w0
	mov	w0,datbuff	;2
	call	sendlcd
	mov	#0x08,w0
	mov	w0,datbuff	;3
	call	sendlcd
	mov	#0x04,w0 
	mov	w0,datbuff	;4
	call	sendlcd
	mov	#0x00,w0
	mov	w0,datbuff	;5
	call	sendlcd
	mov	#0x24,w0
	mov	w0,datbuff	;6
	call	sendlcd
	mov	#0x00,w0
	mov	w0,datbuff	;7
	call	sendlcd
	mov	#0x1c,w0
	mov	w0,datbuff	;8
	call	sendlcd
	mov	#0x08,w0
 	mov	w0,datbuff	;9
	call	sendlcd
	mov	#0x0d,w0
 	mov	w0,datbuff	;a
	call	sendlcd
	mov	#0x09,w0
 	mov	w0,datbuff	;b
	call	sendlcd
	return
;------------------------------
bld_byte:
	mov	w0,upper	;send data
	sl	w0,#4,w0
	mov	w0,lower
	bset	lower,#0
	bclr	lower,#1
	bset	lower,#2
	bset	lower,#3		
	bset	upper,#0	;read data
	goto	ext
;------------------------------
bld_command:
	mov	w0,upper	;send command
	sl	w0,#4,w0
	mov	w0,lower
	bclr	lower,#0
	bclr	lower,#1
	bset	lower,#2
	bset	lower,#3		
	bclr	upper,#0	;write command
ext:
	bclr	upper,#1
	bset	upper,#2
	bset	upper,#3
	mov	upper,w0
	mov	w0,datbuff
	call	sendlcd
	bclr	upper,#2
	mov	upper,w0
	mov	w0,datbuff
	call	sendlcd
	mov	lower,w0
	mov	w0,datbuff
	call	sendlcd
	bclr	lower,#2
	mov	lower,w0
	mov	w0,datbuff
	call	sendlcd	
	return
;------------------------------
header_LCD:
	mov	#0x7e,w0	;lcd address
	mov	w0,datbuff
	call	sendlcd		;send 7e address to i2c chip
	return
;---------------------------------
sendlcd:
	mov	datbuff,w0	;saved data
	mov	w0,temp2	;this will get destroyed
	mov	#0x08,w0	;send 8 bits
	mov	w0,temp1
send8_i2c:
	bclr	LATE,#sda
	btsc	temp2,#0x07
	bset	LATE,#sda	;set data bit	
	sl	temp2	
	call	i2c_clk_LCD
	dec	temp1
	bra	nz,send8_i2c
	bset	LATE,#sda
	call	i2c_clk_LCD	;ack bit clock
	return
;----------------------
start_LCD:
	bclr	LATE,#sda
	call	I2C_dly
	bclr	LATE,#scl	;LCD start condition
	return
;----------------------
stop_LCD:
	bset	LATE,#scl
	call	I2C_dly
	bset	LATE,#sda	;LCD stop condition
	return
;---------------------------------------------------------
i2c_clk_LCD:
	bset	LATE,#scl
	call	I2C_dly
	bclr	LATE,#scl	;LCD clock pulse
	return
;------------- load buffers to display ram --------
;---------- Line 1 Main Data ------------------
line1_Flash_data:
	mov	#0x20,w0	; " "
	mov	w0,line_1
	mov	#0x4e,w0	; "N"
	mov	w0,line_2
	mov	#0x4f,w0	; "O"
	mov	w0,line_3
	mov	#0x54,w0	; "T"
	mov	w0,line_4
	mov	#0x20,w0	; " "
	mov	w0,line_5
	mov	#0x4c,w0	; "L"
	mov	w0,line_6
	mov	#0x4f,w0	; "O"	
	mov	w0,line_7
	mov	#0x43,w0	; "C"
	mov	w0,line_8
	mov	#0x4b,w0	; "K"
	mov	w0,line_9
	mov	#0x45,w0	; "E"
	mov	w0,line_10
	mov	#0x44,w0	; "D"
	mov	w0,line_11
	mov	#0x20,w0	; " "
	mov	w0,line_12
	mov	#0x59,w0	; "Y"
	mov	w0,line_13
	mov	#0x45,w0	; "E"	
	mov	w0,line_14
	mov	#0x54,w0	; "T"	
	mov	w0,line_15
	mov	#0x20,w0	; " "
	mov	w0,line_16
	return
line1_data:
	mov	#0x20,w0	; " "
	mov	w0,line_1
	mov	#0x53,w0	; "S"
	mov	w0,line_2
	mov	#0x54,w0	; "T"
	mov	w0,line_3
	mov	#0x41,w0	; "A"
	mov	w0,line_4
	mov	#0x4E,w0	; "N"
	mov	w0,line_5
	mov	#0x44,w0	; "D"
	mov	w0,line_6
	mov	#0x41,w0	; "A"	
	mov	w0,line_7
	mov	#0x52,w0	; "R"
	mov	w0,line_8
	mov	#0x44,w0	; "D"
	mov	w0,line_9
	mov	#0x20,w0	; " "
	mov	w0,line_10
	mov	#0x4C,w0	; "L"
	mov	w0,line_11
	mov	#0x4F,w0	; "0"
	mov	w0,line_12
	mov	#0x43,w0	; "C"
	mov	w0,line_13
	mov	#0x4B,w0	; "K"	
	mov	w0,line_14
	mov	#0x45,w0	; "E"	
	mov	w0,line_15
	mov	#0x44,w0	; "D"
	mov	w0,line_16
	return
;---------------------------------------
line2_data:
	mov	#0x30,w2
	mov	dig1,w0
	add	w2,w0,w0	
	mov	w0,line_17	;10,000MHz
	mov	dig2,w0
	add	w2,w0,w0		
	mov	w0,line_18	;1,000
	mov	dig3,w0
	add	w2,w0,w0		
	mov	w0,line_19	;100
	mov	dig4,w0
	add	w2,w0,w0	
	mov	w0,line_20	;10
	mov	dig5,w0
	add	#0x30,w0
	mov	w0,line_21	;1MHz
	mov	#0x2e,w0
	mov	w0,line_22
	mov	dig6,w0	
	add	#0x30,w0
	mov	w0,line_23	;100KHz
	mov	dig7,w0
	add	#0x30,w0
	mov	w0,line_24	;10
	mov	dig8,w0
	add	#0x30,w0
	mov	w0,line_25	;1KHz
	mov	#0x2c,w0
	mov	w0,line_26
	mov	dig9,w0
	add	#0x30,w0
	mov	w0,line_27	;100Hz
	mov	dig10,w0
	add	#0x30,w0
	mov	w0,line_28	;10Hz
	mov	dig11,w0
	add	#0x30,w0
	mov	w0,line_29	;1Hz
	mov	#0x4d,w0
	mov	w0,line_30	;MHz
	mov	#0x48,w0
	mov	w0,line_31
	mov	#0x7a,w0
	mov	w0,line_32
	return
;------------------------------------------
send_buff1:
	mov	line_1,w0
	call	bld_byte
	mov	line_2,w0
	call	bld_byte
	mov	line_3,w0
	call	bld_byte
	mov	line_4,w0
	call	bld_byte
	mov	line_5,w0
	call	bld_byte
	mov	line_6,w0
	call	bld_byte
	mov	line_7,w0
	call	bld_byte
	mov	line_8,w0
	call	bld_byte
	mov	line_9,w0
	call	bld_byte
	mov	line_10,w0
	call	bld_byte
	mov	line_11,w0
	call	bld_byte
	mov	line_12,w0
	call	bld_byte
	mov	line_13,w0
	call	bld_byte
	mov	line_14,w0
	call	bld_byte
	mov	line_15,w0
	call	bld_byte
	mov	line_16,w0
	call	bld_byte
	return
send_buff2:
	mov	line_17,w0
	call	bld_byte
	mov	line_18,w0
	call	bld_byte
	mov	line_19,w0
	call	bld_byte
	mov	line_20,w0
	call	bld_byte
	mov	line_21,w0
	call	bld_byte
	mov	line_22,w0
	call	bld_byte
	mov	line_23,w0
	call	bld_byte
	mov	line_24,w0
	call	bld_byte
	mov	line_25,w0
	call	bld_byte
	mov	line_26,w0
	call	bld_byte
	mov	line_27,w0
	call	bld_byte
	mov	line_28,w0
	call	bld_byte
	mov	line_29,w0
	call	bld_byte
	mov	line_30,w0
	call	bld_byte
	mov	line_31,w0
	call	bld_byte
	mov	line_32,w0
	call	bld_byte
	return
;--------------------------- SET UP PORTS -----------------
init_ports:
	clr	PTCON
	clr	PWMCON1
	clr	OVDCON
	clr	LATB
	clr	LATD
	mov	#0x01,w0	;0=output 1=input
	mov	w0,TRISB	;Range input RB0
	mov	#0x60c0,w0	;T1 & T2 Inputs
	mov	w0,TRISC	;
	mov	#0x01,w0
	mov	w0,TRISD	;Lock input RD0
	clr	TRISE
	call	stop_LCD
	bclr	LATB,#sw1
	bclr	LATB,#sw2	;set to DIV by 256
	bset	CNPU1,#0
	bset	CNPU1,#1
	bset	CNPU1,#2	;input pull-upps RB0,T1,T2
	return
;-------------------- init timers -----------
init_timers:
	clr	T1CON
	clr	T2CON
	clr	T3CON
	clr	TMR1
	clr	TMR2
	clr	TMR3
	mov	#49999,w0	;49,999
	mov	w0,PR1	
	dec2	w0,w0
	mov	w0,TMR1
	mov	#0Xffff,w0
	mov	w0,PR3
	mov	w0,PR2
	bset	IPC0,#T1IP0
	bclr	IPC0,#T1IP1
	bclr	IPC0,#T1IP2	;level 1 interrupt
	bclr	IFS0,#T1IF
	bset	IEC0,#T1IE	;start interrupts
	mov	#0x8006,w0
	mov	w0,T1CON
	repeat	#1000
	nop
	bset	IPC1,#T3IP0
	bclr	IPC1,#T3IP1
	bclr	IPC1,#T3IP2	;level 1 interrupt
	bclr	IFS0,#T2IF
	bclr	IFS0,#T3IF
	bclr	IEC0,#T3IE	;stop	interrupts
	bclr	IEC0,#T2IE	;stop	interrupts
	mov	#0x000A,w0	;32 bit prescaler set to 8 level 1 interrupt
	mov	w0,T2CON
	bset	T2CON,#TON	;timer on
	return
;----------------- powerup delay -----------
powerup:
	clr	delay1
lp1:
	dec	delay1
	bra	nz,lp1
	return
;------------------------- small delay ------------------
I2C_dly:
	repeat	#1080
	nop
	return
;--------------------------
delay:
	clr	delay1
	clr	delay2
	inc	delay2
	inc	delay2
	inc	delay2
	inc	delay2
lp256:
	dec	delay1
	bra	nz,lp256
	dec	delay2
	bra	nz,lp256
	return
;-------------- RESTORE FREQ --------
restore:
	call	index1
	TBLRDL	[w0],w4
	mov	w4,count
	call	index2
	TBLRDL	[w0],w4
	mov	w4,tcg_numb
	return
;------------ SAVE FREQ DATA TO EEPROM -----------
erase:
	mov	w0,NVMADR
	mov	w1,NVMADRU
	mov	#0x4044,w0
	mov	w0,NVMCON
	call	key
	return
;---------------------- 
save_ee1:
	call	index1
	call	erase
	call	index1
	mov	count,w2
	TBLWTL	w2,[w0]
	mov	#0x4004,w0
	mov	w0,NVMCON
	call	key
	return
save_ee2:
	call	index2
	call	erase
	call	key
	call	index2
	mov	tcg_numb,w2
	TBLWTL	w2,[w0]
	mov	#0x4004,w0
	mov	w0,NVMCON
	call	key
	return
;------------------ SAVE ONE WORD IN EERPOM -------------
key:
	DISI	#5
	mov	#0x55,w0
	mov	w0,NVMKEY
	mov	#0xaa,w1
	mov	w1,NVMKEY
	bset	NVMCON,#WR
notdone:
	btsc	NVMCON,#WR	
	bra	notdone
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC10)-------------------------
index1:
	mov	#0xfc10,w0
	mov	#0x7f,w1
	mov	w1,TBLPAG
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC30)-------------------------
index2:
	mov	#0xfc30,w0
	mov	#0x7f,w1
	mov	w1,TBLPAG
	return
;------------------------ end of program ---------------------

	.section eeprom, eedata

mydata:	.byte	0x12	;0x7ffc00
	.byte	0x34
	.word	0x6970



	.end		

	